package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot10061ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot10061ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10061CheckPackageID extends ProtBase {

	private final short iTaskCode10061 = 10061;
	private Gson gson;
	private Prot10061ResBean resBean;
	
	public Prot10061ResBean getRes(){
		return resBean;
	}

	public Prot10061CheckPackageID() {
		gson = new Gson();
	}

	public void dealCheckPackageId(SocketCreate create, Prot10061ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis, Prot10061ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10061, "开始请求车站列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				// 服务器可能分多次包返回数据
				recLoginDis(dis);
			}
		}
	}

	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10061, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10061, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			 resBean = gson.fromJson(jsonData, Prot10061ResBean.class);
		} 

		recCheckCode(dis);

	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10061ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		// String bodyContent = "{label_id:"+labelId+"}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10061, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
